; Triplets V1.0
; By Robin Kay
;

; You may not distribute a modified version of this program. However, you
; may take code from or base your program on this code providing that the
; resulting program is at least 50% of your own work.

.nolist
#include "tse.inc"
.list
.org    usermem-3
.db     $BB,$6D
 ret

.db "TSE",1              ; header
prgtitle:
.db " Triplets", 0 ; title
.dw 80                   ; stack required

start:

 ; Dispaly main menu
 bcall(_clrscrnfull)
 ld hl, 0
 ld (currow), hl
 ld hl, prgtitle + 1
 call putStr
 ld hl, author
 call putStr
 bcall(_newline)
 ld hl, txt1
 call putStr
 ld hl, txt2
 call putStr
 bcall(_newline)
 bcall(_newline)
 ld hl, hstxt
 bcall(_puts)
 ld hl, (highscore)
 bcall(_disphl)

 ; Poll for keypad on menu
loop:
 ei
 halt ; Save power
 bcall(_getcsc)

 cp sk2nd
 jr z, maingame

 ; Process other keys
 cp skclear
 jr z, clrhs

 ; Yield
 cp skStat
 jr nz, dontyield
 call _tseforceyield
 jr start
dontyield:
 jr loop

; Clear highscore
clrhs:
 ld hl, 0
 ld (highscore), hl
 jr start 

; Main game routine
maingame:

 ; Reset score
 ld hl, 0
 ld (score), hl

 ; Init bucketx
 ld a, (92/2)-4
 ld (bucketx), a

 ; Init objects & buffer
 ld hl, obj1x
 ld b, 12 + 13 + 1
initobjloop:
 ld (hl), 0
 inc hl
 djnz initobjloop

gameloop:

 ; Clear gbuf
 bcall(_GrBufClr)

 ; Delay
 ; !

 ; Update objects
 ld hl, obj4t
 ld b, 4
drawobjloop:
 push bc

 ; Check if object active
 ld a, (hl)
 cp 0
 jp z, notactive

 ; Active
 sla a
 sla a
 sla a
 ld e, a
 ld d, 0
 ld ix, square
 add ix, de
 dec hl
 ld a, (hl)
 inc a
 cp 64-18
 jr z, hitbottom
 ld (hl), a
 dec hl
 push hl
 ld b, a
 ld l, (hl)
 ld h, 0
 ld de, plotsscreen - 12
 add hl, de
 ld de, 12
 inc b
loop1:
 add hl, de
 djnz loop1
 ld b, 8
loop2:
 ld a, (ix)
 ld (hl), a
 add hl, de
 inc ix
 djnz loop2
 pop hl
 jp doneobj

 ; Hit Bottom
hitbottom:
 inc hl
 ld b, (hl)
 ld (hl), 0
 dec hl
 dec hl
 ld a, (bucketx)
 add a, 4
 sra a
 sra a
 sra a
 ld c, (hl)
 cp c
 jr nz, doneobj

 ; Hit Bucket
hitbucket:
 ld de, (score)
 inc de
 ld (score), de
 ld a, 4
 cp b
 jr nz, notbomb
 xor a
 ld (bufsize), a
 ld hl, (score)
 dec hl
 ld (score), hl
 jr doneobj
notbomb:
 ld a, (bufsize)
 inc a
 cp 13
 jp z, done
 ld (bufsize), a
 push hl
 ld hl, buffer
 ld e, a
 ld d, 0
 add hl, de
 ld (hl), b
 ld c, b
 ld b, 3
matchloop:
 ld a, (hl)
 cp c
 jr nz, nomatch
 dec hl
 djnz matchloop
 ld hl, (score)
 ld bc, 5
 add hl, bc
 ld (score), hl
 ld a, (bufsize)
 add a, -3
 ld (bufsize), a
nomatch:
 pop hl
 jr doneobj

 ; Not Active
notactive:
 ld b, 20 ; 1 in 20 change of respawn
 call ionRandom
 cp 0
 jr z, respawn
 dec hl
 dec hl
 jr doneobj

 ; Respawn
respawn:
 ld b, 30 ; 1 in 30 change of bomb
 call ionRandom
 cp 4
 jr z, dropbomb
 ld b, 4
 call ionRandom
dropbomb:
 ld (hl), a
 dec hl
 ld (hl), 0
 dec hl
 ld b, 12
 call ionRandom
 ld (hl), a

doneobj:
 dec hl
 pop bc
 dec b
 xor a
 cp b
 jp nz, drawobjloop

 ; Draw bucket
 ld a, (bucketx)
 ld l, 63-14
 ld ix, bucket
 ld b, 3
 call ionPutSprite

 ; Draw line
 ld b, 12
 ld hl, plotsscreen+((63-10)*12)
lineloop:
 ld (hl), 0ffh
 inc hl
 djnz lineloop

 ; Draw buffer
 ld a, (bufsize)
 cp 0
 jr z, empty
 ld b, a
 ld hl, buffer
 ld a, (bufsize)
 ld e, a
 ld d, 0
 add hl, de
drawbuf:
 push bc
 push hl
 ld a, (hl)
 sla a
 sla a
 sla a
 ld e, a
 ld d, 0
 ld ix, square
 add ix, de
 dec b
 ld l, b
 ld h, 0
 ld de, plotsscreen + (55*12)
 add hl, de
 ld de, 12
 ld b, 8
loop3:
 ld a, (ix)
 ld (hl), a
 add hl, de
 inc ix
 djnz loop3
 pop hl
 pop bc
 dec hl
 djnz drawbuf
empty:

 ; Display score
 ld hl, 0
 ld (pencol), hl
 ld hl, (score)
 ld c, '0'
 ld de, saferam5+6
 xor a
 ld (de), a
FormatHLloop:
 bcall(_divHLby10)
 dec de
 add a, c
 ld (de), a
 ld a, h
 or l
 jr nz,FormatHLloop
 ex de,hl
 set textWrite, (iy+sGrFlags)
 bcall(_vputs)
 res textWrite, (iy+sGrFlags)

 ; Draw onto screen
 call ionFastCopy

 ; Process keypad
 ld a,kreset
 out (1),a
 ld a,group1
 out (1),a
 in a,(1)
 cp kright
 jr z, right
 cp kleft
 jr nz, nothing
left:
 ld a, (bucketx)
 dec a
 cp -1
 jr z, nothing
 ld (bucketx), a
 jr nothing
right:
 ld a, (bucketx)
 inc a
 cp 96-8
 jr z, nothing
 ld (bucketx), a
nothing:

 ; Check for quit
 ld a, kreset
 out (1), a
 ld a, group2
 out (1), a
 in a, (1)
 cp kClear
 jr z, done
  
 ; Yield
 ld a, kreset
 out (1),a
 ld a, group4
 out (1),a
 in a,(1)
 cp KStat
 jp nz, gameloop
 call _tseforceyield
 jp gameloop

; Hiscore screen
done:
 bcall(_clrscrnfull)
 ld hl, 0
 ld (currow), hl
 ld hl, scrtxt
 bcall(_puts)
 ld hl, (score)
 bcall(_disphl)
 bcall(_newline)
 ld hl, (score)
 ld de, (highscore)
 inc de
 bcall(_cphlde)
 jr c, nohighscore

 ld (highscore), hl
 ld hl, newhs
 bcall(_puts)

nohighscore:
 ei
 halt ; Save power
 bcall(_getcsc)
 cp skMode
 jp z, start
 cp skStat
 jr nz, nohighscore
 call z, _tseforceyield
 jr done

; Display string and then advance a line onwards
putStr:
 bcall(_puts)
 bcall(_newline)
 ret

; --Data--
highscore:
.dw 0
author:
.db "By Robin Kay", 0
txt1:
.db "2nd: Start Game",0
txt2:
.db "Clr: Reset HS",0
hstxt:
.db "Hi-"
scrtxt
.db "Score: ",0
newhs:
.db "New HighScore!!",0
bucket:
.db %10000001
.db %01000010
.db %01111110
square:
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
circle:
.db %00011000
.db %00111100
.db %01111110
.db %11111111
.db %11111111
.db %01111110
.db %00111100
.db %00011000
triangle:
.db %10000000
.db %11000000
.db %11100000
.db %11110000
.db %11111000
.db %11111100
.db %11111110
.db %11111111
cross:
.db %00011000
.db %00011000
.db %00011000
.db %11111111
.db %11111111
.db %00011000
.db %00011000
.db %00011000
bomb:
.db %11000011
.db %11100111
.db %01111110
.db %00111100
.db %00111100
.db %01111110
.db %11100111
.db %11000011

; --Variables--
extdata:
score        .equ extdata + 0
bucketx      .equ score   + 2
obj1x        .equ bucketx + 1
obj1y        .equ obj1x   + 1
obj1t        .equ obj1y   + 1
obj2x        .equ obj1t   + 1
obj2y        .equ obj2x   + 1  
obj2t        .equ obj2y   + 1
obj3x        .equ obj2t   + 1
obj3y        .equ obj3x   + 1
obj3t        .equ obj3y   + 1
obj4x        .equ obj3t   + 1
obj4y        .equ obj4x   + 1
obj4t        .equ obj4y   + 1
buffer       .equ obj4t   + 1
bufsize      .equ buffer  + 13 ; Extra byte needed

.end
